import 'package:api_manager/api_manager.dart';

/// Created by Taohid on 02, March, 2020
/// Email: taohid32@gmail.com

class AuthInterceptor extends Interceptor {
  AuthInterceptor(this._authTokenListener);

  AuthTokenListener _authTokenListener;

  @override
  void onRequest(
    RequestOptions options,
    RequestInterceptorHandler handler,
  ) async {
    if (options.headers.containsKey("isauthrequired") == true &&
        options.headers["isauthrequired"] == true) {
      options.headers.remove("isauthrequired");
      String token = await _authTokenListener();
      options.headers.addAll({
        "Authorization": token,
      });
      handler.next(options);
    } else {
      handler.next(options);
    }
  }
}
